<%
#pragma link "mash.exe"
using System;
using System.Collections.Generic;

// パラメータを取得
bool   runnable = _IN.ContainsKey("run");
string source   = _IN["source"  ] + "";
string language = _IN["language"] + "";

string fileName   = "";
string fileSource = "";
string fileResult = "";
if (runnable)
{
	// コードタイプを取得
	mash.CodeTypes codeType;
	if (language == "VB") codeType = mash.CodeTypes.VisualBasic; else
	if (language == "JS") codeType = mash.CodeTypes.JScript    ; else
	codeType = mash.CodeTypes.CSharp;
	
	// 定義文を分離
	string declSource = "";
	string mainSource = "";
	foreach (string line in source.Split('\n'))
	{
		string trimmedLine = line.Replace("\t", " ").Trim();
		bool   declared    = false;
		if (codeType == mash.CodeTypes.CSharp)
		{
			declared = trimmedLine.StartsWith("using ");
		}
		else if (codeType == mash.CodeTypes.VisualBasic)
		{
			declared = (trimmedLine.StartsWith("imports ") || trimmedLine.StartsWith("option "));
		}
		if (codeType == mash.CodeTypes.JScript)
		{
			declared = trimmedLine.StartsWith("import ");
		}
		if (declared)
		{
			declSource += line + "\n";
		}
		else
		{
			mainSource += line + "\n";
		}
	}
	
	// ソースを作成
	string className  = "ExampleSourceClass";
	string methodName = "ExampleSourceMethod";
	if (codeType == mash.CodeTypes.VisualBasic)
	{
		fileName    = className + ".vb";
		fileSource  = declSource;
		fileSource += "public class " + className + "\n";
		fileSource += "	public shared function " + methodName + "() as object\n";
		fileSource += "		' ここから手入力したソース\n";
		fileSource += mainSource;
		fileSource += "		' ここまで手入力したソース\n";
		fileSource += "		return nothing\n";
		fileSource += "	end function\n";
		fileSource += "end class";
	}
	else if (codeType == mash.CodeTypes.JScript)
	{
		fileName    = className + ".js";
		fileSource  = declSource;
		fileSource += "public class " + className + "\n";
		fileSource += "{\n";
		fileSource += "	public static function " + methodName + "()\n";
		fileSource += "	{\n";
		fileSource += "		// ここから手入力したソース\n";
		fileSource += mainSource;
		fileSource += "		// ここまで手入力したソース\n";
		fileSource += "		return null;\n";
		fileSource += "	}\n";
		fileSource += "}";
	}
	else
	{
		fileName    = className + ".cs";
		fileSource  = declSource;
		fileSource += "public class " + className + "\n";
		fileSource += "{\n";
		fileSource += "	public static object " + methodName + "()\n";
		fileSource += "	{\n";
		fileSource += "		// ここから手入力したソース\n";
		fileSource += mainSource;
		fileSource += "		// ここまで手入力したソース\n";
		fileSource += "		return null;\n";
		fileSource += "	}\n";
		fileSource += "}";
	}
	
	// ソースを実行
	try
	{
		fileResult = mash.MarshalCodeUtility.Execute(fileName, fileSource, null, codeType, className, methodName) + "";
	}
	catch (Exception e)
	{
		fileResult = e.ToString();
	}
	
	// ソースに行番号を付ける
	string tempSource = "";
	int    tempLineNo = 1;
	foreach (string line in fileSource.Split('\n'))
	{
		tempSource += tempLineNo.ToString("0000") + ": " + line + "\n";
		tempLineNo ++;
	}
	fileSource = tempSource;
}
%>
<%$ include("header.tpl") %>

<b>手入力のスクリプトを実行するサンプル</b>（ExampleSource.tpl）<br><br>
ソースを入力して実行すると、実際に実行されたソースと戻り値が、ページ下部に表示されます。<br><br>
<hr>

<form action="ExampleSource.tpl">
	
	ソース（クラスとメソッドの定義は不要です）<br>
	<textarea name="source" style="width:100%; height:100px;"><%$ source %></textarea><br>
	<input name="run" type="submit" value="実行">
	<input name="language" type="radio" value="CS" <%$ language == "" || language == "CS" ? "checked" : "" %>>C#
	<input name="language" type="radio" value="VB" <%$ language == "VB" ? "checked" : "" %>>Visual Basic
	<input name="language" type="radio" value="JS" <%$ language == "JS" ? "checked" : "" %>>JScript
	
</form>
<hr>

<% if (fileSource != "") { %>
	実行された戻り値：<br>
	<table border="1" width="100%"><tr><td><pre><%$ fileResult %></pre></td></tr></table>
	
	実行されたソース：<br>
	<table border="1" width="100%"><tr><td><pre><%$ fileSource %></pre></td></tr></table>
<% } %>

<%$ include("footer.tpl") %>
