﻿// ---------------------------------------------------------------------------
// 拡張子「.csv」の拡張スクリプト
// 
// 概要
//   カンマ区切りを、HTMLのテーブルで出力します。
//   ※エスケープ文字等は考慮していません。
// ---------------------------------------------------------------------------

using System;
using System.IO;
using System.Text;

// csvクラス
public class csv
{
	// スタティックメソッド
	public static void Main(string[] args)
	{
		// 引数を取得
		string fileName = args[1];
		
		// HTMLを作成
		StringBuilder sb = new StringBuilder();
		
		sb.Append("<html>");
		sb.Append("<body>");
		sb.Append("<table border=\"1\">");
		string text = File.ReadAllText(fileName).Replace("\r", "");
		if (text.Length > 0)
		{
			string[] lines = text.Split('\n');
			foreach (string line in lines)
			{
				sb.Append("<tr>");
				if (line.Length > 0)
				{
					string[] columns = line.Split(',');
					foreach (string column in columns)
					{
						sb.Append("<td>");
						sb.Append(column);
						sb.Append("</td>");
					}
				}
				sb.Append("</tr>");
			}
		}
		sb.Append("</table>");
		sb.Append("</body>");
		sb.Append("</html>");
		
		// HTMLを出力
		Console.Write(sb.ToString());
	}
}
